# -*- coding: utf-8 -*-

"""
    test_meraki

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from test_meraki.api_helper import APIHelper
from test_meraki.configuration import Configuration
from test_meraki.controllers.base_controller import BaseController
from test_meraki.http.auth.custom_header_auth import CustomHeaderAuth

class MRL3FirewallController(BaseController):

    """A Controller to access Endpoints in the test_meraki API."""


    def get_network_ssid_l_3_firewall_rules(self,
                                            network_id,
                                            number):
        """Does a GET request to /networks/{networkId}/ssids/{number}/l3FirewallRules.

        Return the L3 firewall rules for an SSID on an MR network

        Args:
            network_id (string): TODO: type description here. Example: 
            number (string): TODO: type description here. Example: 

        Returns:
            object: Response from the API. Successful operation

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/networks/{networkId}/ssids/{number}/l3FirewallRules'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'networkId': network_id,
            'number': number
        })
        _query_builder = Configuration.base_uri
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare and execute request
        _request = self.http_client.get(_query_url)
        CustomHeaderAuth.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return _context.response.raw_body

    def update_network_ssid_l_3_firewall_rules(self,
                                               network_id,
                                               number,
                                               update_network_ssid_l_3_firewall_rules=None):
        """Does a PUT request to /networks/{networkId}/ssids/{number}/l3FirewallRules.

        Update the L3 firewall rules of an SSID on an MR network

        Args:
            network_id (string): TODO: type description here. Example: 
            number (string): TODO: type description here. Example: 
            update_network_ssid_l_3_firewall_rules
                (UpdateNetworkSsidL3FirewallRules, optional): TODO: type
                description here. Example: 

        Returns:
            object: Response from the API. Successful operation

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/networks/{networkId}/ssids/{number}/l3FirewallRules'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'networkId': network_id,
            'number': number
        })
        _query_builder = Configuration.base_uri
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'content-type': 'application/json; charset=utf-8'
        }

        # Prepare and execute request
        _request = self.http_client.put(_query_url, headers=_headers, parameters=APIHelper.json_serialize(update_network_ssid_l_3_firewall_rules))
        CustomHeaderAuth.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return _context.response.raw_body
